100 REM PRTREAD Program to read PRINTER.BIN file ---- M.D.Kaser ---- Oct.8,1991
110 REM Compatible with: BASICA Ver.3.3,  GWBASIC Ver 3.2,
120 REM                  Turbo BASIC 3.0, Quick BASIC 4.0
130 REM Check your BASIC manual concerning RANDOM ACCESS FILES.
135 DIM FUN$(20), NUM$(20), SIZE%(20), CODE1$(20), CODE2$(20)
140 REM
160 OPEN "PRINTER.BIN" AS #1 LEN = 28
170 FIELD #1, 5 AS T$, 1 AS N$, 1 AS L$, 1 AS R$, 18 AS C$, 2 AS D$
180 REM       Define the bytes for each String Buffer variable
190 CLS
200 RECORD = 1
205 REM       Read first HEADER record and seperate the variables
210 GET #1, RECORD
220   PINS%  = ASC(T$)
230   CODE%  = ASC(MID$(T$,2,1))
240   NCODE% = ASC(MID$(T$,3,1))
250   DIR%   = ASC(MID$(T$,4,1))
260   FLAG%  = 256*ASC(N$) + ASC(RIGHT$(T$,1))
270   WIDE%  = 256*ASC(R$) + ASC(L$)
280   WDTH   = WIDE%/100
285   MFG$   = C$+D$
290 REM        Remove the binary zeros from the end of MFG$
300 I = 0
310 I = I + 1
320   A = ASC(MID$(MFG$,I,1))
330   IF A > 31 GOTO 310
340   MFG$ = LEFT$(MFG$,(I-1))
350 REM       Read second HEADER record and seperate the variables
360 RECORD = 2
370 GET #1, RECORD
380   TYPE%  = ASC(T$)
390   COLR%  = ASC(MID$(T$,2,1))
400   CTYPE% = ASC(MID$(T$,3,1))
410 REM       The fourth character is not currently used.
420   HEAD%  = 256*ASC(N$) + ASC(RIGHT$(T$,1))
430   LONG%  = 256*ASC(R$) + ASC(L$)
440   LENGTH = LONG%/100
450   MODEL$ = C$+D$
460 REM        Now remove binary zeros from the end of MODEL$
470 I = 0
480 I = I + 1
490   A = ASC(MID$(MODEL$,I,1))
500   IF A > 31 GOTO 480
510   MODEL$ = LEFT$(MODEL$,(I-1))
520 REM       Now show the HEADER variables.
530 PRINT "Ŀ"
540 PRINT "     Read the PRINTER.BIN file to get printer setup and codes    "
550 PRINT ""
560 PRINT "Printer: "+MFG$+" "+MODEL$
565 PRINT
570 PRINT "PINS:";PINS%,"CODE:";CODE%,"NCODE:";NCODE%,"DIR:";DIR%,"FLAG:";FLAG%
580 PRINT "TYPE:";TYPE%,"COLORS:";COLR%,"CTYPE:";CTYPE%,"HEAD:";HEAD%
590 PRINT "WIDTH:";WIDE%,"LENGTH:";LONG%
592 PRINT
595 PRINT "The";NCODE%;" codes are:"
600 REM                                  Get and save each code line
610 FOR I=1 TO NCODE%
620     GET #1, (I+2)
630     FUN$(I) = T$
632     NUM$(I) = ""
634     IF ASC(N$) > 0 THEN NUM$(I) = LEFT$(N$,1)
640     SIZE%(I) = 256*ASC(R$) + ASC(L$)
650     CODE1$(I) = C$
660     CODE2$(I) = D$
670 REM                           Strip binary zeros from end of CODE1$
680     J = 0
682     L = LEN(CODE1$(I))
690     J = J + 1
695     IF J > L GOTO 720
700     A = ASC(MID$(CODE1$(I),J,1))
710     IF (A > 0)  GOTO 690
720     CODE1$(I) = LEFT$(CODE1$(I),(J-1))
730 REM                           Strip binary zeros from end of CODE2$
740     J = 0
750     J = J + 1
755     IF J > 2 GOTO 780
760     A = ASC(MID$(CODE2$(I),J,1))
770     IF (A > 0) GOTO 690
780     IF (J > 1) THEN CODE2$(I) = LEFT$(CODE2$(I),(J-1))
790 REM                           Now display the code string
800     PRINT "    ";FUN$(I);SIZE%(I);
810     J = LEN(CODE1$(I))
820     FOR K=1 TO J
830         PRINT ASC(MID$(CODE1$(I),K,1));
840         NEXT K
850     PRINT " ";NUM$(I);
860     J = LEN(CODE2$(I))
870     FOR K=1 TO J
880         PRINT ASC(MID$(CODE2$(I),K,1));
890         NEXT K
900     PRINT " "
910
920     NEXT I
980 CLOSE #1
990 END
